package com.app.testinit;

/**
 * Rezolvarea in Java a problemei celor mai mari 3 medii din fisierul text
 * primit ca argument si al numelor elevilor care au acele medii
 *
 * @author calin
 */
public class Aplicatie {

    static final String COMMENT_MARKER = "#";

    static void afiseazaCele3noteMari(String NumeFisierCatalog) {

        //Elev []EleviTari = new Elev[] {null, null, null};
        Elev[] EleviTari = new Elev[3]; // array cu celule null. 
        // Nu sunt call-uri la constructor Elev, pentru ca nu exista un 
        //  constructor fara argumente in clasa Elev

        Catalog cat = new Catalog(NumeFisierCatalog);
        if (false == cat.open()) {
            System.out.println("Nu am putut deschide fisierul de catalog " + NumeFisierCatalog);
            return;
        }

        String linie = null;
        do {
            linie = cat.getNextLine();
            if (linie == null) {
                break;
            }

            linie = linie.trim();
            if (linie.startsWith(COMMENT_MARKER)) {
                continue;
            }

            String[] strs = linie.split(" ");
            if (strs.length < 4) {
                continue;
            }

            String NumeElev = strs[0];
            String PrenumeElev = strs[1];
            double notamate = Double.parseDouble(strs[2]);
            double notarom = Double.parseDouble(strs[3]);
            Elev currentElev = new Elev(NumeElev, PrenumeElev, notamate, notarom);

            int i;
            for (i = 0; i < EleviTari.length; i++) {
                if (EleviTari[i] != null) {
                    // toti ceilalti elevi au note mai mici, inclusiv elevul i
                    if (EleviTari[i].getMedia() < currentElev.getMedia()) {
                        break;
                    }
                } else // unii din elevii tari sunt null => se va suprascrie cu currentElev mai jos
                {
                    break;
                }
            }

            // toti elevii de la i pana la sfarsit sunt impinsi mai jos
            for (int j = i; j < EleviTari.length - 1; j++) {
                EleviTari[j + 1] = EleviTari[j];
            }

            // suprascrie elevul tare i, cu currentElev, pentru ca are media mai mare
            // doar daca currentElev a avut media mai mare ca unul din cei 3
            if (i < EleviTari.length) {
                EleviTari[i] = currentElev;
            }

        } while (true);

        cat.close();

        for (int i = 0; i < EleviTari.length; i++) {
            if (EleviTari[i] != null) {
                System.out.println(EleviTari[i].toString());
            }
        }
    }
}
