package com.app.testinit;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

/**
 *
 * @author calin
 */
public class Catalog {

    String NumeFisierCatalog;
    FileReader Fr;
    BufferedReader Br;
    boolean IsOpen;

    /**
     * Constructor for a new Catalog object
     *
     * @param _NumeFisierCatalog String with the name of the file containing
     * grades
     */
    public Catalog(String _NumeFisierCatalog) {
        NumeFisierCatalog = _NumeFisierCatalog;
        IsOpen = false;
    }

    /**
     * Function that opens the inner catalog file
     *
     * @return true if ok, false if could not open
     */
    public boolean open() {
        try {
            //BufferedReader br = new BufferedReader(new FileReader(NumeFisierCatalog));
            Fr = new FileReader(NumeFisierCatalog);
            Br = new BufferedReader(Fr);
            IsOpen = true;
        } catch (FileNotFoundException ex) {
        } finally {
            return IsOpen;
        }
    }

    /**
     * Function that closes the inner catalog file
     *
     * @return true if ok, false if could not close
     */
    public boolean close() {
        try {
            if (Br != null) {
                Br.close();
            }
            if (Fr != null) {
                Fr.close();
            }
            IsOpen = false;
        } catch (IOException ex) {
            Br = null;
            Fr = null;
            IsOpen = false;
        }

        return IsOpen;
    }

    /**
     * Returns state of catalog file
     *
     * @return true if open, false otherwise
     */
    private boolean isOpen() {
        return IsOpen;
    }

    /**
     * Read a new line from file
     *
     * @return String representing the new line or null if file ended or is not
     * open
     */
    public String getNextLine() {
        if (isOpen()) {
            try {
                return Br.readLine();
            } catch (IOException ex) {
                return null;
            }
        }
        return null;
    }
}
